package org.shiftone.jrat.core.command;

import org.shiftone.jrat.core.spi.Commandlet;
import org.shiftone.jrat.util.log.Logger;

import java.io.OutputStream;

/**
 * dumps system propeties.
 *
 * @author jeff@shiftone.org (Jeff Drost)
 */
public class SystemPropertiesCommandlet implements Commandlet {
    private static final Logger LOG = Logger.getLogger(SystemPropertiesCommandlet.class);

    public void execute(OutputStream output) throws Exception {
        System.getProperties().store(output, "Generated by " + getClass().getName());
    }

    public String getContentType() {
        return Commandlet.ContentType.PLAIN;
    }

    public String getTitle() {
        return "Dump System Properties";
    }
}
